<template>
    <div>
        <q-dialog v-model="showChangeLang">
            <q-card style="width: 450px; max-width: 50vw;">
                <q-card-section>
                    <div class="text-h6">{{ $t("dashboard.change_language") }}</div>
                </q-card-section>

                <q-card-section class="q-pt-none">
                    <LanguagePicker :fullwidth="true" />
                </q-card-section>

                <q-card-actions align="right">
                    <q-btn flat :label="$t('ok')" color="primary" v-close-popup />
                </q-card-actions>
            </q-card>
        </q-dialog>

        <q-toolbar :class="eventlogOffset ? 'pl-toolbar-drawer' : 'pl-toolbar'">
            <q-btn v-if="hasBackButton" flat round dense icon="arrow_back"
                @click="overrideBack ? $router.push(overrideBack) : $router.back()" />

            <q-toolbar-title> {{ pageTitle }} </q-toolbar-title>

            <q-btn v-if="showAdmin" flat icon-right="admin_panel_settings" :label="$t('dashboard.admin_menu')">
                <q-menu>
                    <q-list style="min-width: 200px">
                        <q-item>
                            <q-toggle @input="showAllUsersCb" :value="showAllUsersVal" left-label
                                :label="$t('dashboard.admin_show_all')" />
                        </q-item>
                        <q-item clickable v-close-popup @click="() => this.$router.push({ path: 'admin/allbilling' })">
                            <q-item-section>
                                {{ $t("dashboard.admin_billing_overview") }}
                            </q-item-section>
                        </q-item>
                        <q-item clickable v-close-popup @click="() => this.$router.push({ path: 'admin/allowed' })">
                            <q-item-section>
                                {{ $t("dashboard.admin_allowed_users") }}
                            </q-item-section>
                        </q-item>
                        <q-item clickable v-close-popup @click="() => this.$router.push({ path: 'admin/trunks' })">
                            <q-item-section>
                                {{ $t("dashboard.admin_trunks") }}
                            </q-item-section>
                        </q-item>
                        <q-item clickable v-close-popup @click="() => this.$router.push({ path: 'admin/adminrights' })">
                            <q-item-section>
                                {{ $t("dashboard.admin_admins") }}
                            </q-item-section>
                        </q-item>
                        <q-item clickable v-close-popup @click="goToDocs">
                            <q-item-section>
                                {{ $t("dashboard.admin_docs") }}
                            </q-item-section>
                        </q-item>
                    </q-list>
                </q-menu>

            </q-btn>


            <q-btn v-if="showContacts" flat icon-right="contacts" :label="$t('contacts.page_title')"
                @click="$router.push('/contacts')" />

            <q-btn flat round dense icon="more_vert">
                <q-menu>
                    <q-list style="min-width: 200px">
                        <q-item clickable v-close-popup @click="showChangeLang = true">
                            <q-item-section>
                                {{ $t("dashboard.change_language") }}
                            </q-item-section>
                        </q-item>
                        <q-item clickable v-close-popup @click="handleLogOut">
                            <q-item-section>
                                {{ $t("dashboard.logout") }}
                            </q-item-section>
                        </q-item>
                    </q-list>
                </q-menu>
            </q-btn>

        </q-toolbar>
    </div>
</template>
<script>

import { auth } from "../firebase";
import LanguagePicker from "../components/LanguagePicker.vue";

export default {
    props: {
        hasBackButton: {
            type: Boolean,
            default: true
        },
        overrideBack: {
            type: String,
            default: null
        },
        pageTitle: {
            type: String,
            default: ''
        },
        showContacts: {
            type: Boolean,
            default: false
        },
        eventlogOffset: {
            type: Boolean,
            default: false
        },
        showAdmin: {
            type: Boolean,
            default: false
        },
        showAllUsersCb: {
            type: Function
        },
        showAllUsersVal: {
            type: Boolean
        },
    },
    data()
    {
        return {
            showChangeLang: false
        };
    },
    methods: {
        handleLogOut()
        {
            this.$q.dialog({
                title: this.$t("confirm"),
                message: this.$t("dashboard.logout_confirm_message"),
                ok: { label: this.$t("dashboard.logout"), flat: true, color: "negative" },
                cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
            })
                .onOk(async () =>
                {
                    await auth.signOut();
                    this.$router.push({
                        path: "welcome",
                    })
                });
        },
        goToDocs()
        {
            window.location.replace('https://docs.paroli.live');
        }
    },
    components: {
        LanguagePicker
    },
};
</script>
<style scoped></style>